#include-once

#include "Error.au3"

#include <Array.au3>

Func ProcessCommandLine(Const $Text, Const $IncludeQuotes = False)
	Local $Return[1]

	Local $Buffer
	Local $Index
	Local $Parameter

	; Validate the arguments.
	If Not IsString($Text) Then
		SetError($ERROR_DATATYPE, 0)
		Return 0
	EndIf

	If Not IsBool($IncludeQuotes) Then
		SetError($ERROR_DATATYPE, 0)
		Return 0
	EndIf

	$Return[0] = 0
	$Buffer = $Text

	While StringLen($Buffer) <> 0
		Switch StringLeft($Buffer, 1)
			Case " " ; If a space is found, trim it.
				$Buffer = StringMid($Buffer, 2)
			Case """" ; We found a quoted parameter. Extract characters until the end of the string or until another quote is found.
				; Remove the quote before finding the ending quote.
				$Buffer = StringMid($Buffer, 2)

				$Index = StringInStr($Buffer, """")

				If $Index = 0 Then
					$Parameter = $Buffer
					$Buffer = ""
				Else
					$Parameter = StringLeft($Buffer, $Index - 1)
					$Buffer = StringMid($Buffer, $Index + 1)
				EndIf

				If $IncludeQuotes Then
					$Parameter = """" & $Parameter & """"
				EndIf

				SetError($ERROR_NONE)
				_ArrayAdd($Return, $Parameter)
				If @error <> 0 Then
					SetError($ERROR_INSUFFICIENTMEMORY)
					Return 0
				EndIf
				$Return[0] += 1
			Case Else ; We found a normal parameter. Extract characters until the end of the string or until a space is found.
				$Index = StringInStr($Buffer, " ")

				If $Index = 0 Then
					$Parameter = $Buffer
					$Buffer = ""
				Else
					$Parameter = StringLeft($Buffer, $Index - 1)
					$Buffer = StringMid($Buffer, $Index + 1)
				EndIf

				SetError($ERROR_NONE)
				_ArrayAdd($Return, $Parameter)
				If @error <> 0 Then
					SetError($ERROR_INSUFFICIENTMEMORY)
					Return 0
				EndIf
				$Return[0] += 1
		EndSwitch
	WEnd

	Return $Return
EndFunc